﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
    
    public class Player extends FlxSprite
    {
        [Embed(source = '../../data/gfx/player.png')] public static var ImgPlayer:Class;
        
        private var _move_speed:int = 2000;
        private var _jump_power:int = 800;   
        private var _max_health:int = 10;
		public var direction:int = 0;
		private var _moving:Boolean = false;
		private var _canmove:Boolean = true;
		
        public function Player(X:Number,Y:Number,Dir:String):void
        {
            super(ImgPlayer, X, Y, true, true);//Max speeds
						
            maxVelocity.x = 50;
            maxVelocity.y = 50;
            //Set the player health
            health = 10;
            //Gravity
            acceleration.y = 0;            
            //Friction
            drag.x = 800;
            drag.y = 800;
            //bounding box tweaks
            width = 9
            height = 9;
            offset.x = 0;
            offset.y = 0;
			addAnimation("none",[0,1,2,3,4,5,6,7,8,9,10,11]);
			addAnimation("standingup",[0]);
			addAnimation("standingdown",[0]);
			addAnimation("standingleft",[3]);
			addAnimation("standingright",[3]);
			addAnimation("walkingup",[1,2],3);
			addAnimation("walkingdown",[2,1],3);
			addAnimation("walkingleft",[5,4],3);
			addAnimation("walkingright",[4,5],3);
			
			play("none");
			switch(Dir.toLowerCase())
			{
				case "up":
				this.specificFrame(0);
				this._curFrame = 0;
				direction = 0;
				break;
				case "down":
				this.specificFrame(1);
				this._curFrame = 1;
				direction = 1;
				break;
				case "left":
				this.specificFrame(3);
				this._curFrame = 3;
				direction = 2;
				break;
				case "right":
				this.specificFrame(2);
				this._curFrame = 2;
				direction = 3;
				break;
			}
			this.update();
        }
    
		public function stop():void
		{
			_canmove = false;
			play("none");
			switch(direction)
			{
				case 0:
				this.specificFrame(0);
				this._curFrame = 0;
				break;
				case 1:
				this.specificFrame(1);
				this._curFrame = 1;
				break;
				case 2:
				this.specificFrame(3);
				this._curFrame = 3;
				break;
				case 3:
				this.specificFrame(2);
				this._curFrame = 2;
				break;
			}
			this.update();
		}
		
		public function start():void
		{
			_canmove = true;
		}
        override public function update():void
        {
            super.update();			

			var oldmoving:Boolean;
			oldmoving = _moving;
			var olddir:int;
			_moving = false;
			

			if (FlxG.kDown)
			{
				velocity.y += _move_speed * FlxG.elapsed;
				if (oldmoving && this._curAnim.name!="walkingdown"&&!(FlxG.kLeft||FlxG.kRight))
					this.play("walkingdown");
				_moving = true;
				direction = 1;
			}
            if(FlxG.kLeft)
            {
                velocity.x -= _move_speed * FlxG.elapsed;
				if (oldmoving && this._curAnim.name != "walkingleft"&&!FlxG.kUp)
				{
					this.play("walkingleft");
				}
				_moving = true;
				direction = 2;
            }
            if (FlxG.kRight)
            {
                velocity.x += _move_speed * FlxG.elapsed;  
				if (oldmoving && this._curAnim.name!="walkingright"&&!FlxG.kUp)
					this.play("walkingright");
				_moving = true;
				direction = 3;
            }
			if (FlxG.kUp)
			{
				velocity.y -= _move_speed * FlxG.elapsed;
				if (oldmoving && this._curAnim.name!="walkingup")
					this.play("walkingup");
				_moving = true;
				direction = 0;
			}
			
			if (!_moving)
			{
				switch(direction)
				{
					case 0:
					this.play("standingup");
					break;
					case 1:
					this.play("standingdown");
					break;
					case 2:
					this.play("standingleft");
					break;
					case 3:
					this.play("standingright");
					break;
				}
			}
			
			if (x < 8)
			{
				if (FlxG.level < 9)
				{
					FlxG.oldlevel = FlxG.level;
					FlxG.level=9
				}
				else
				{
					if (y < 3 * 16)
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 1;
					}
					else
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 7;
					}
				}		
//				WalkState.fromMenu = false;
				FlxG.switchState(WalkState);		
			}
			else if (x > FlxG.width - 16- 8)
			{
				if (FlxG.level < 9)
				{
					FlxG.oldlevel = FlxG.level;
					FlxG.level=9
				}
				else
				{
					if (y < 3 * 16)
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 6;
					}
					else
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 0;
					}
				}			
//				WalkState.fromMenu = false;
				FlxG.switchState(WalkState);	
			}
			else if (y < 8)
			{
				if (FlxG.level < 9)
				{
					FlxG.oldlevel = FlxG.level;
					FlxG.level=9
				}
				else
				{
					if (x < 3 * 16)
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 8;
					}
					else if (x < 5 * 16)
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 5;
					}
					else
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 3;
					}
				}			
//				WalkState.fromMenu = false;
				FlxG.switchState(WalkState);	
			}
			else if (y > FlxG.height - 16 - 16 - 8)
			{
				if (FlxG.level < 9)
				{
					FlxG.oldlevel = FlxG.level;
					FlxG.level=9
				}
				else
				{
					if (x < 3 * 16)
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 4;
					}
					else
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 2;
					}
				}
//				WalkState.fromMenu = false;
				FlxG.switchState(WalkState);				
			}
			
        }    
    }
}