﻿package com.Tutorial 
{
    import com.adamatomic.flixel.*;
	import flash.geom.Rectangle;
	
	/**
	 * ...
	 * @author Stephen Lavelle
	 */
	public class WalkState extends FlxState
	{
	    [Embed(source = '../../data/levels/flat.txt', mimeType = "application/octet-stream")] private var MainRoom:Class;
        [Embed(source = '../../data/gfx/tiles.png')] public static var ImgTiles:Class;
        [Embed(source = '../../data/gfx/map.png')] public static var ImgMap:Class;
				
        public static var lyrBG:FlxLayer;
		public static var lyrPlayer:FlxLayer;
		public static var lyrHUD:FlxLayer;
		
		private var fading:Boolean;
		private var _descText:FlxText;
		private var _intDescr:String;
		
		private var _overlapfound:Boolean;
		private var _caninteractwith:int;

		private var _map:FlxTilemap;
		
		private var _player:Player;
		
		private var _interactables:FlxArray;
		
		private var interactionstate:int;//0 normal, 1 menu, 2 talk
		
		public function WalkState() 
		{
			FlxG.setMusic(MenuState.SndHouse2);

			interactionstate = 0;
			
			lyrBG = new FlxLayer;
			lyrPlayer = new FlxLayer;
			lyrHUD = new FlxLayer;		
			
			_interactables = new FlxArray;
			fading = false;
			_interactables.push(new Interactable(11,121,11,11,"comp"));
			_interactables.push(new Interactable(22,143,33,22,"bed"));
			_interactables.push(new Interactable(143,22,11,11,"hob"));
			_interactables.push(new Interactable(22,22,22,11,"books"));
			_interactables.push(new Interactable(22,66,11,22,"books"));
			_interactables.push(new Interactable(44,88,22,11,"books"));
			_interactables.push(new Interactable(121,143,11,11,"door"));

			_player = new Player(10*11, 13*11,"left");
			
			lyrPlayer.add(_player);
			_player.update();
			lyrPlayer.update();

			_map = new FlxTilemap(new MainRoom , ImgTiles, 1 );
			
			lyrBG.add(new FlxSprite(ImgMap));
			
			_descText = new FlxText(0, 176, FlxG.width, 20, "", 0xff9bd8d7,null,8,"center");
			_descText.visible = false;
			lyrHUD.add(_descText);
			_intDescr = new String;
//			_statusblock = new FlxSprite(null, 0, 128, false, false, FlxG.width, 16, 0xff8d431f);
			
//			lyrHUD.add(_statusblock);
			
			this.add(lyrBG);
			this.add(lyrPlayer);
			this.add(lyrHUD);
			
			FlxG.flash(0xff000000,1);

		}
		
		override public function update():void
        {
			if (fading)
				return;
			super.update();
			_map.collide(_player);
			
			var cacheX:Number = _player.x;
			var cacheY:Number = _player.y;
			
			switch (_player.direction)
			{
				case 0:
					_player.y -= 10;
					break;
				case 1:
					_player.y += 10;
					break;
				case 2:
					_player.x -= 10;
					break;
				case 3:
					_player.x += 10;
					break;
			}
			_overlapfound = false;
			_caninteractwith = -1;
			
			FlxG.overlapArray(_interactables, _player, interactfound);
			if (_overlapfound)
			{
				_descText.setText(_intDescr);
				_descText.visible = true;
			}
			else
			{
				_descText.visible = false;				
			}
			
			
			_player.x = cacheX;
			_player.y = cacheY;
			
			if (_caninteractwith == 2)
			{
				if (FlxG.justPressed(FlxG.A)&&!fading)
				{
					fading = true;
					FlxG.play(MenuState.SndOpen);
		            FlxG.fade(0xff000000, 2,nextState);
				}
			}
		}
		
		public function nextState():void
		{
			FlxG.switchState(SexState);
		}
		
		public function interactfound(npc:Interactable, p:Player):void
		{
			if (npc.s == "bed")
			{
				_intDescr = "You don't feel tired";
				_overlapfound = true;
				_caninteractwith = 1;
			}
			else if (npc.s == "comp")
			{
				_intDescr = "Hook up with someone online";
				_overlapfound = true;
				_caninteractwith = 2;
			}
			else if (npc.s == "hob")
			{
				_intDescr = "There's no food in the flat";
				_overlapfound = true;
				_caninteractwith = 2;
			}
			else if (npc.s == "books")
			{
				_intDescr = "You don't feel like reading";
				_overlapfound = true;
				_caninteractwith = 2;
			}
			else if (npc.s == "door")
			{
				_intDescr = "It's cold out";
				_overlapfound = true;
				_caninteractwith = 2;
			}
		}
		
	}

}